%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Main differences to C(++)}

\begin{itemize}[<+->]
  \item Fortran is case-insensitive
  \item Procedure/Function arguments
  \item Internal procedures
  \item Fortran arrays
  \item Allocatables and pointers
  \item Generic procedures
  \item Scope and data access
\end{itemize}
  
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Procedure/Function Arguments}

\begin{itemize}
  \item C/C++: pass by value
  \begin{itemize}
    \item Compiler places a copy of the argument onto the stack
    \item Changing the local variable does not change the variable of caller
    \item In order to change the variable, we need to pass a pointer or reference
  \end{itemize} 
  \item Fortran: pass by reference
  \begin{itemize}
    \item Compiler places the address of the variable
    \item Variable of caller can be changed
    \item Variables access can be controlled by {\tt intent} attribute
  \end{itemize} 
  \item Intent(): IN, OUT, INOUT
\end{itemize}

\end{frame}

\begin{frame}[fragile] \frametitle{Variable intent}

  {\small
\lstset{language=Fortran}
\begin{lstlisting}
integer, intent(IN|OUT|INOUT) :: variable
\end{lstlisting}
  }
  \begin{description}
    \item [IN]
    \begin{itemize}
      \item Variable must be defined on function entry
      \item Variable must not be changed in the function
    \end{itemize}
    \item [OUT]
    \begin{itemize}
      \item Variable undefined on function entry
      \item Variable must be set in the function
      \item Variable must be a storage location \\
      (no literal or function result)
    \end{itemize}
    \item [INOUT]
    \begin{itemize}
      \item Variable must be defined on function entry
      \item Variable can be changed in the function
      \item Variable must be storage location
    \end{itemize}
  \end{description}

  Without {\tt intent} attribute, no checks. (Dangerous)
  
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Arrays}

  \begin{itemize}[<+->]
    \item C/C++ (no STL): 
    \begin{itemize} 
      \item arrays are pointers to memory
      \item first element starts at index 0
      \item only 1-dimensional
      \item more dimensions: either direct index arithmetic or array of pointers
      \item always contiguous in memory
      \item row major
      \item need to store dimensions separately
    \end{itemize}
    \item Fortran:
    \begin{itemize}
      \item native support for more dimensions (column major)
      \item default for lower index: 1 (can be specified)
      \item array stores information about dimensions
      \begin{itemize}
        \item {\tt shape, lbound, ubound, size}
      \end{itemize}
      \item Array operations
      \item elemental functions
      \item Array slizes (e.g. {\tt A(2:5, 1:2)})
      \item non-contiguous in memory
    \end{itemize}
  \end{itemize}

\end{frame}

\begin{frame}[fragile] \frametitle{Array inquiry }

  \begin{description}[<+->]
    \item[{\tt shape(array)}] rank 1 array with sizes
    \item[{\tt lbound(array [,dim])}] lower bounds
    \item[{\tt ubound(array [,dim])}] upper bounds
    \item[{\tt size(array [,dim])}] number of elements
  \end{description}

  If {\tt dim} is provided, {\tt lbound, ubound} and {\tt size} return scalar,
  otherwise rank-1 array
{\small
\lstset{language=Fortran}
\begin{lstlisting}
  do i=lbound(A,2), ubound(A,2)
    do j=lbound(A,1), ubound(A,1)
      A(i,j) = ...
    end do
  end do
\end{lstlisting}
}

\end{frame}

\begin{frame}[fragile] \frametitle{Intrinsic array reductions (I)}

  \begin{description}[<+->]
    \item[{\tt all(mask [,dim])}] {\tt .true.} if all elements are {\tt .true.}
    \item[{\tt any(mask [,dim])}] {\tt .true.} if any element is {\tt .true.}
    \item[{\tt count(mask [,dim])}] number of elements that are {\tt .true.}
  \end{description}

  \begin{description}[<+->]
    \item[{\tt maxval(array [,dim][,mask])}] maximum of (masked) array values
    \item[{\tt minval(array [,dim][,mask])}] minimum of (masked) array values
  \end{description}

  \begin{description}[<+->]
    \item[{\tt sum(array [,dim][,mask])}] sum of (masked) array values
    \item[{\tt product(array [,dim][,mask])}] product of (masked) array values
  \end{description}

  \vspace*{5mm}
  {\tt mask} needs to be of the same shape as {\tt array}

\end{frame}

\begin{frame}[fragile] \frametitle{Intrinsic array reductions (II)}

\begin{itemize}[<+->]
\item Finding an element:
  \begin{description}[<+->]
    \item[{\tt maxloc(array [,dim][,mask])}] location of maximum
    \item[{\tt minloc(array [,dim][,mask])}] location of minimum
    \item[{\tt findloc(array, value [,dim][,mask])}] location of element with given value
  \end{description}

\item Mathematical functions:
  \begin{description}[<+->]
    \item[{\tt dot{\_}product(vec1, vec2)}] scalar product
    \item[{\tt matmul(A, B)}] matrix multiplication
    \item[{\tt transpose(A)}] transposition 
  \end{description}
\end{itemize}

\end{frame}

\begin{frame}[fragile] \frametitle{The {\tt where} construct}

Operate on all array elements fullfilling some condition:
{\small
\lstset{language=Fortran}
\begin{lstlisting}

  where(a < 0.0)
    a = 0.0
  elsewhere(a>10)
    a = 10.0
  end where

\end{lstlisting}
}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\begin{frame}[fragile] \frametitle{Allocatable Variables}

\begin{itemize}[<+->]
  \item in C/C++: only pointers
  \item in Fortran: attribute {\tt allocatable}
  \item declaration: only rank need to be known
  \item {\tt allocate} generate storage
  \item {\tt deallocate} release storage
  \item {\tt allocated()} query status
  \item automatic deallocation when variable goes out of scope
\end{itemize}

\end{frame}

\begin{frame}[fragile] \frametitle{Allocatable and Array Example}

{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
  program my_program

  implicit none
  integer                       :: a(1:5) = [ 1, 2, 3, 4, 5 ]
  integer, dimension(1:5, 1:2)  :: b
  integer, allocatable          :: c(:,:)

  allocate(c(1:2, 1:5))

  b(:, 1) = 2*a       ! with OpenMP explicit loop can be faster
  b(:, 2) = square(a)

  c = 0
  c(:, 1) = a(2:3)
  c(:, 2) = a(2:4:2) ! elements a(2) and a(4) in two-dim array (non-contiguous)

  print *, sum(a(1:5:2)), sum(a, MASK=MOD(a,2)==0)

  deallocate(c)

contains

  integer pure elemental function square(x)
    integer, intent(in) :: x

    square = x*x
  end function square

end program my_program
\end{lstlisting}
}

\end{frame}

\begin{frame}[fragile] \frametitle{Fortran Pointers}

\begin{itemize}[<+->]
  \item in C: 
  \begin{itemize}
    \item pointer is just the memory address
    \item need to 'dereference' with '*'
    \item no other information (only type)
  \end{itemize}
  \item in Fortran:
  \begin{itemize}
    \item needs to be of same rank
    \item association with target: {\tt ptr => target}
    \item status: {\tt associated()}
    \item pointer keeps information about shape
    \item No pointer arithmetic possible
    \item allocated pointers are not automatically deallocated
  \end{itemize}
\end{itemize}

\end{frame}

\begin{frame}[fragile] \frametitle{Internal procedures}

  \begin{itemize}[<+->]
    \item Also procedures/functions can have a {\tt contains} block
    \item these contained functions defined there
    \begin{itemize}
      \item are visible only to that function
      \item can access all local variables of the 'host' function
    \end{itemize}
    \item We have some in Octopus, but in general these are considered bad practice
  \end{itemize}
\end{frame}

\begin{frame}[fragile] \frametitle {Scoped and namespaces}

  \begin{itemize}[<+->]
    \item No 'namespace' as in C++
    \item Symbols from all included modules are available
    \item Hiding unused symbols by {\tt only}
    \item Symbols can be renamed when using a module
    \item Best practice: make all private by default, and expose only what you want to expose
  \end{itemize}

\end{frame}


\begin{frame} \frametitle{Further information}
  
  Some links to Fortran tutorials for further reading:
  \begin{itemize}
    \item \url{https://fortran-lang.org/en/learn/quickstart/}
    \item \url{https://www.tutorialspoint.com/fortran/index.htm}
    \item \url{https://www.fortrantutorial.com/}
  \end{itemize}

  \vspace*{5mm}
  Reference Manuals:
  \begin{itemize}
    \item \url{https://gcc.gnu.org/onlinedocs/gfortran/index.html}
  \item \url{https://www.intel.com/content/www/us/en/docs/fortran-compiler/developer-guide-reference/2024-1/language-reference.html}
  \end{itemize}


\end{frame}